/*
 * Copyright 2017 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kie.dmn.feel.runtime;

import org.kie.dmn.feel.lang.EvaluationContext;

public class UnaryTestImpl implements UnaryTest {
    private final String text;
    private final UnaryTest delegate;
   
    public UnaryTestImpl(UnaryTest delegate, String text) {
        this.text = text;
        this.delegate = delegate;
    }
   
    @Override
    public String toString() {
        return text;
    }
   
    @Override
    public Boolean apply(EvaluationContext ctx, Object obj) {
        return delegate.apply(ctx, obj);
    }
}
